Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/HomeController.cs
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/HomeController.cs	(revision 13804)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/HomeController.cs	(revision 13805)
@@ -93,4 +93,8 @@
             }
         }
+        /// <summary>
+        /// Redirect user to home sceen for a full logout
+        /// </summary>
+        /// <returns></returns>
         public IActionResult Logout()
         {
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/ResourceController.cs
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/ResourceController.cs	(revision 13804)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/ResourceController.cs	(revision 13805)
@@ -14,4 +14,7 @@
 namespace HeuristicLab.Clients.Hive.WebJobManager.Controllers
 {
+    /// <summary>
+    /// Controller for the resources. Only handles requests that refresh the page.
+    /// </summary>
     public class ResourceController : Controller
     {
@@ -29,4 +32,8 @@
             _environment = env;
         }
+        /// <summary>
+        /// Initialize and check the login. Gets all the required services for the user.  
+        /// </summary>
+        /// <returns></returns>
         private bool init()
         {
@@ -46,4 +53,8 @@
             }
         }
+        /// <summary>
+        /// Loads the main page for the resources
+        /// </summary>
+        /// <returns></returns>
         public IActionResult Index()
         {
@@ -60,4 +71,10 @@
             }
         }
+        /// <summary>
+        /// Changes the parent for a specfic resource
+        /// </summary>
+        /// <param name="inpid">Resource to edit</param>
+        /// <param name="inpidpar">New parent resource</param>
+        /// <returns></returns>
         [HttpPost]
         public IActionResult changeParent(string inpid, string inpidpar)
@@ -70,17 +87,22 @@
                 adminClient.Refresh();
                 var tochange = adminClient.Resources.ToList().Find(x => x.Id == gid);
-                
+                //gets current resource
                 if (inpidpar != null && inpidpar != "") {
                     Guid tempid = Guid.Parse(inpidpar);
-                    while (tempid != null)
-                    {
+                    while (tempid != null && tempid != Guid.Empty)
+                    {//Check if a loop could occur (some parent of the parent being the parent)
                         if (tempid != gid)
-                        {
-                            tempid = (Guid)adminClient.Resources.ToList().Find(x => x.Id == tempid).ParentResourceId;
+                        {//Not equal so move up a level
+                            var t = adminClient.Resources.ToList().Find(x => x.Id == tempid);
+                            if (t.ParentResourceId == null)
+                                tempid = Guid.Empty;
+                            else
+                                tempid = (Guid)t.ParentResourceId;
+
                         }
                         else
-                            break;
-                    }
-                    if(tempid == null)
+                            break; //breaks loop if equal 
+                    }
+                    if(tempid == null || tempid == Guid.Empty)//Broken loop => the tempid is not empty so no change
                         tochange.ParentResourceId = Guid.Parse(inpidpar);
                 }
@@ -88,12 +110,66 @@
                     tochange.ParentResourceId = null;
                 adminClient.Store(tochange, CancellationToken.None);
-
-                return RedirectToAction("Index", "Resource");
-            }
-            else
-            {
-                return RedirectToAction("Index", "Home");
-            }
-        }
+                //Save to server
+
+                return RedirectToAction("Index", "Resource");
+            }
+            else
+            {
+                return RedirectToAction("Index", "Home");
+            }
+        }
+        /// <summary>
+        /// Adds recources to a resource group
+        /// </summary>
+        /// <param name="addres">Array containing all the resources ID's from the group</param>
+        /// <param name="groupid">Group id</param>
+        /// <returns></returns>
+        [HttpPost]
+        public IActionResult addResourcesToGroup(string[] addres, string groupid)
+        {
+            if (init())
+            {
+                Guid gid = Guid.Parse(groupid);
+                adminClient.Refresh();
+                var exist = adminClient.Resources.ToList().FindAll(x => x.ParentResourceId == gid);
+                //Current existing member of the group
+
+                foreach(var a in addres)
+                {//loop on each ID 
+                    Guid tempid = Guid.Parse(a);
+                    var elemid = exist.FindIndex(x => x.Id == tempid);
+                    if (elemid != -1)
+                    {//If element already is a member of the group: scramble temporary ID (for future reference) 
+                        exist[elemid].Id = Guid.Empty;
+                    }
+                    else
+                    {//If element is not yet in list => change parentresourceid from that element
+                        var obj = adminClient.Resources.ToList().Find(x => x.Id == tempid);
+                        obj.ParentResourceId = gid;
+                        adminClient.Store(obj, CancellationToken.None);
+                    }
+                }
+                foreach(var e in exist)
+                {//Loop on existing and check the ID's
+                    if(e.Id != Guid.Empty)
+                    {//ID != Empty means that element should not be a member of the list anymore
+                        e.ParentResourceId = null; //remove ParentResourceID from element
+                        adminClient.Store(e, CancellationToken.None);
+                    }
+                }
+
+                return RedirectToAction("Index", "Resource");
+
+            }
+            else
+            {
+                return RedirectToAction("Index", "Home");
+            }
+        }
+        /// <summary>
+        /// Delete a client group (relinks the parent from every member to possible grandparent) 
+        /// </summary>
+        /// <param name="inpid">Group ID to delete</param>
+        /// <returns></returns>
         [HttpPost]
         public IActionResult deleteClientGroup(string inpid)
@@ -105,7 +181,9 @@
                 adminClient.Refresh();
                 var group = adminClient.Resources.ToList().Find(x => x.Id == gid);
+                //Group to delete
                 var list = adminClient.Resources.ToList().FindAll(x => x.ParentResourceId == gid);
+                //All members from the group
                 foreach(var cl in list)
-                {
+                {//Links parent from every child to parent from the group to delete.
                     cl.ParentResourceId = group.ParentResourceId;
                     adminClient.Store(cl, CancellationToken.None);
@@ -120,5 +198,12 @@
             }
         }
-
+        /// <summary>
+        /// Create a new Client Group
+        /// </summary>
+        /// <param name="inpname">Name for the group</param>
+        /// <param name="inpheart">Heartbeat</param>
+        /// <param name="inpparent">Possible parent for the group</param>
+        /// <param name="clientstoadd">Clients to be added to the group</param>
+        /// <returns></returns>
         [HttpPost]
         public IActionResult newClientGroup(string inpname, int inpheart, string inpparent, string[] clientstoadd)
@@ -128,15 +213,18 @@
 
                 SlaveGroup sg = new SlaveGroup();
+                //init
                 sg.Id = Guid.Empty;
                 sg.Name = inpname;
                 sg.HbInterval = inpheart;
-                if (inpparent != "")
+                if (inpparent != null)
                     sg.ParentResourceId = Guid.Parse(inpparent);
+
                 sg.OwnerUserId = serviceLocator.getHiveServiceClient().GetUserIdByUsername(serviceLocator.getHiveServiceClient().ClientCredentials.UserName.UserName);
                 adminClient.Store(sg, CancellationToken.None);
                 adminClient.Refresh();
+                //Reloads the resources
                 var id = adminClient.Resources.ToList().Find(x => x.Name == inpname).Id;
                 foreach(var s in clientstoadd)
-                {
+                {//Loop so each client can be added to the group
                     var cid = Guid.Parse(s);
                     var client = adminClient.Resources.ToList().Find(x => x.Id == cid);
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/UserController.cs
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/UserController.cs	(revision 13804)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/UserController.cs	(revision 13805)
@@ -8,4 +8,5 @@
 using System.Collections.Generic;
 using System.Linq;
+using System.Net.Mail;
 using System.ServiceModel.Security;
 using System.Threading.Tasks;
@@ -13,4 +14,7 @@
 namespace HeuristicLab.Clients.Hive.WebJobManager.Controllers
 {
+    /// <summary>
+    /// Handles all the actions for user management
+    /// </summary>
     public class UserController : Controller
     {
@@ -27,4 +31,8 @@
             _environment = env;
         }
+        /// <summary>
+        /// Init required services and checks login
+        /// </summary>
+        /// <returns></returns>
         private bool init()
         {
@@ -44,5 +52,8 @@
         }
         #region Users
-
+        /// <summary>
+        /// Show users page
+        /// </summary>
+        /// <returns></returns>
         public IActionResult Index()
         {
@@ -51,4 +62,5 @@
                 ViewBag.Title = "Users";
                 UserViewModel vm = new UserViewModel(accessClient).refreshAll() ;
+                //Refreshall for users, groups and roles 
                 ViewBag.SessionId = HttpContext.Session.GetString("UserId");
                 return View("Index", vm);
@@ -62,5 +74,4 @@
         public IActionResult SelectUser(string id)
         {
-            ;
             if (init())
             {
@@ -69,9 +80,9 @@
                 UserViewModel vm = new UserViewModel(accessClient).refreshAll();
                 if (curr == Guid.Empty)
-                {
+                {//new user
                     ViewBag.Title = "Add User";
                 }
                 else
-                {
+                {//View an existing user
                     vm.SelectedUser = vm.getUserById(curr);
                     vm.SelectedUserSubscriptions = accessClient.getSubscribedGroups(curr);
@@ -82,10 +93,21 @@
                 ViewBag.SessionId = HttpContext.Session.GetString("UserId");
                 return View("Index", vm);
-            }
-            else
-            {
-                return RedirectToAction("Index", "Home");
-            }
-        }
+                //Uses Index page too, with the additional info in the Viewmodel
+            }
+            else
+            {
+                return RedirectToAction("Index", "Home");
+            }
+        }
+        /// <summary>
+        /// Saves an existing user or adds a new user
+        /// </summary>
+        /// <param name="inpusername">Username</param>
+        /// <param name="inpfullname">Full name </param>
+        /// <param name="inpemail">Email</param>
+        /// <param name="u">User ID</param>
+        /// <param name="rolestoadd">Roles to add to the user</param>
+        /// <param name="groupstoadd">Groups to subscribe the user to</param>
+        /// <returns></returns>
         [HttpPost]
         public IActionResult saveUser(string inpusername, string inpfullname, string inpemail, string u, string[] rolestoadd, string[] groupstoadd)
@@ -96,5 +118,5 @@
                 var uid = Guid.Parse(u);
                 Access.User user;
-                if (uid == Guid.Empty)
+                if (uid == Guid.Empty)//checks if user is new or exists
                     user = new Access.User();
                 else
@@ -107,18 +129,21 @@
 
                 if (uid == Guid.Empty)
-                {
+                {//New user
                     user.UserName = inpusername;
                     uid = accessClient.addUser(user);
+                    var newpass = accessClient.resetPassword(uid);
+                    sendPassmail(accessClient.Users.Find(x => x.Id == uid), newpass);
+                    //password received through mail
                     ViewBag.Title = user.UserName + " added - User";
                 }
                 else
-                {
+                {//Existing user
                     accessClient.updateUser(user);
                     ViewBag.Title = user.UserName + " updated - User";
                 }
-                accessClient.RefreshUsers();
+                accessClient.RefreshUsers();//Refresh data from user
                 user = accessClient.Users.Find(x => x.Id == uid);
                 foreach (var s in rolestoadd)
-                {
+                {//Loop to add roles
                     var role = accessClient.Roles.Find(x => x.Name == s);
 
@@ -127,5 +152,5 @@
                 accessClient.RefreshUserGroups();
                 foreach(var g in groupstoadd)
-                {
+                {//loop to subscribe to groups
                     var gid = Guid.Parse(g);
                     var group = accessClient.Groups.Find(x => x.Id == gid);
@@ -140,4 +165,35 @@
 
         }
+        /// <summary>
+        /// Sends email for a specific user, containg a password
+        /// </summary>
+        /// <param name="u">User to mail</param>
+        /// <param name="pass">Password to send</param>
+        public static void sendPassmail(Access.User u, string pass)
+        {/*
+            SmtpClient smtpClient = new SmtpClient("mail.MyWebsiteDomainName.com", 25);
+
+            smtpClient.Credentials = new System.Net.NetworkCredential("info@MyWebsiteDomainName.com", "myIDPassword");
+            smtpClient.UseDefaultCredentials = true;
+            smtpClient.DeliveryMethod = SmtpDeliveryMethod.Network;
+            smtpClient.EnableSsl = true;
+            MailMessage mail = new MailMessage();
+
+            //Setting From , To and CC
+            mail.From = new MailAddress("info@MyWebsiteDomainName", "MyWeb Site");
+            mail.Subject = "Password changed - HeuristicLab Hive";
+            mail.Body = "Hello " + u.FullName + ", " +
+                "Your password was changed through the HeuristicLab Hive web application." +
+                "The new password for " + u.UserName + " is '" + pass + "'.";
+            mail.To.Add(new MailAddress(u.Email));
+
+            smtpClient.Send(mail);
+            */
+        }
+        /// <summary>
+        /// Delete a user
+        /// </summary>
+        /// <param name="id">User ID to delete</param>
+        /// <returns></returns>
         public IActionResult deleteUser(string id)
         {
@@ -148,5 +204,5 @@
 
                 if (uid == Guid.Empty)
-                {
+                {//check for empty Guid, should not happen but still
                     vm.message = "Something went wrong, user is not deleted";
                     return View("Index", vm);
@@ -157,16 +213,21 @@
                     vm.message = user.UserName + " (" + user.FullName + ") has been deleted";
                     accessClient.DeleteUser(user);
-                    vm.refreshAll();
+                    vm.refreshAll();//refreshAll for index view
                     ViewBag.Title = "Users";
-                    return View("Index", vm);
-                }
-            }
-            else
-            {
-                return RedirectToAction("Index", "Home");
-            }
-
-        }
-
+                    return View("Index", vm);//No redirect to save the viewbag message
+                }
+            }
+            else
+            {
+                return RedirectToAction("Index", "Home");
+            }
+
+        }
+        /// <summary>
+        /// Deletes a role from a user
+        /// </summary>
+        /// <param name="id">User Id</param>
+        /// <param name="role">Role name</param>
+        /// <returns></returns>
         public IActionResult deleteUserRole(string id, string role)
         {
@@ -178,4 +239,5 @@
                 var user = vm.getUserById(uid);
                 var r = vm.getRoleByName(role);
+
                 accessClient.deleteUserRole(user, r);
                 return RedirectToAction("SelectUser", new { id = id });
@@ -186,4 +248,10 @@
             }
         }
+        /// <summary>
+        /// Delete user from a group
+        /// </summary>
+        /// <param name="id">User Id</param>
+        /// <param name="group">Group Id</param>
+        /// <returns></returns>
         public IActionResult deleteUserGroup(string id, string group)
         {
@@ -196,4 +264,5 @@
                 var user = vm.getUserById(mid);
                 var gr = vm.getGroupById(gid);
+                
                 accessClient.deleteMember(user, gr);
                 return RedirectToAction("SelectUser", new { id = id});
@@ -208,4 +277,8 @@
 
         #region Groups
+        /// <summary>
+        /// Shows the groups overview, opening up with "Add group"
+        /// </summary>
+        /// <returns></returns>
         public IActionResult Groups()
         {
@@ -222,4 +295,9 @@
             }
         }
+        /// <summary>
+        /// Show information for a specific group (Guid.empty = new group)
+        /// </summary>
+        /// <param name="id">Group ID</param>
+        /// <returns></returns>
         public IActionResult SelectGroup(string id)
         {
@@ -232,9 +310,9 @@
                     .refreshUsers();
                 if (curr == Guid.Empty)
-                {
+                {//Add group
                     ViewBag.Title = "Add group";
                 }
                 else
-                {
+                {//Show existing group info and possibility to edit
                     vm.SelectedGroup = vm.getGroupById(curr);
                     vm.SelectedGroupMembers = accessClient.getGroupMembers(curr);
@@ -249,4 +327,12 @@
             }
         }
+        /// <summary>
+        /// Saves an exisiting group or adds a new one.
+        /// </summary>
+        /// <param name="inpgroupname">Group name</param>
+        /// <param name="u">Group id (empty for new)</param>
+        /// <param name="userstoadd">Users to add to group</param>
+        /// <param name="groupstoadd">Groups to add to group</param>
+        /// <returns></returns>
         [HttpPost]
         public IActionResult saveGroup(string inpgroupname, string u, string[] userstoadd, string[] groupstoadd)
@@ -259,18 +345,18 @@
                 Access.UserGroup group;
 
+                if (uid == Guid.Empty)//Create new group
+                    group = new Access.UserGroup();
+                else//Find existing group
+                    group = accessClient.Groups.Find(x => x.Id == uid);
+
+                group.Name = inpgroupname;
+
                 if (uid == Guid.Empty)
-                    group = new Access.UserGroup();
-                else
-                    group = accessClient.Groups.Find(x => x.Id == uid);
-
-                group.Name = inpgroupname;
-
-                if (uid == Guid.Empty)
-                {
+                {//New Group add
                     uid = accessClient.addGroup(group);
                     ViewBag.Title = group.Name + " added - Group";
                 }
                 else
-                {
+                {//Existing group update
                     accessClient.updateGroup(group);
                     ViewBag.Title = group.Name + " updated - Group";
@@ -278,6 +364,7 @@
                 vm.refreshGroups();
                 group = vm.getGroupById(uid);
+                //refresh group info
                 foreach (var s in userstoadd)
-                {
+                {//Subscribes members to group
                     var tempid = Guid.Parse(s);
                     var member = vm.getUserById(tempid);
@@ -285,5 +372,5 @@
                 }
                 foreach (var g in groupstoadd)
-                {
+                {//Subscribes groups to group
                     var tempid = Guid.Parse(g);
                     var member = vm.getGroupById(tempid);
@@ -298,4 +385,9 @@
             }
         }
+        /// <summary>
+        /// Delete an existing group
+        /// </summary>
+        /// <param name="id">Group to delete</param>
+        /// <returns></returns>
         public IActionResult deleteGroup(string id)
         {
@@ -306,10 +398,10 @@
 
                 if (uid == Guid.Empty)
-                {
+                {//Check for empty ID, should not happen but still..
                     vm.message = "Something went wrong, group is not deleted";
                     return View("Groups", vm);
                 }
                 else
-                {
+                {//Deletes the user group
                     var group = vm.getGroupById(uid);
                     vm.message = group.Name + " has been deleted";
@@ -325,4 +417,10 @@
 
         }
+        /// <summary>
+        /// Delete a member from a group  
+        /// </summary>
+        /// <param name="g">Group id</param>
+        /// <param name="m">User id</param>
+        /// <returns>Group selected</returns>
         public IActionResult deleteMember(string g, string m)
         {
@@ -334,10 +432,10 @@
 
                 if (gid == Guid.Empty || mid == Guid.Empty)
-                {
+                {//Should not be empty but still..
                     vm.message = "Something went wrong, member is not deleted";
                     return View("Groups", vm);
                 }
                 else
-                {
+                {//Deletes the member
                     var group = vm.getGroupById(gid);
                     Access.UserGroupBase member = vm.getUserById(mid);
@@ -361,4 +459,8 @@
 
         #region Roles
+        /// <summary>
+        /// Shows roles overview, opening with "Add role"
+        /// </summary>
+        /// <returns></returns>
         public IActionResult Roles()
         {
@@ -376,4 +478,9 @@
             }
         }
+        /// <summary>
+        /// Shows information for a specific role 
+        /// </summary>
+        /// <param name="name">Role name</param>
+        /// <returns></returns>
         public IActionResult SelectRole(string name)
         {
@@ -383,9 +490,9 @@
                 UserViewModel vm = new UserViewModel(accessClient).refreshRoles();
                 if (name == "" || name == null)
-                {
+                {//Add role
                     ViewBag.Title = "Add Role";
                 }
                 else
-                {
+                {//Edit/view role
                     vm.SelectedRole = vm.getRoleByName(name);
                     vm.SelectedRoleEnrolled = accessClient.getEnrolled(vm.SelectedRole);
@@ -401,4 +508,9 @@
             }
         }
+        /// <summary>
+        /// Saves a role or adds a new one
+        /// </summary>
+        /// <param name="inprolename">Role name</param>
+        /// <returns></returns>
         [HttpPost]
         public IActionResult saveRole(string inprolename)
@@ -422,4 +534,9 @@
             }
         }
+        /// <summary>
+        /// Delete a role
+        /// </summary>
+        /// <param name="name">Role name</param>
+        /// <returns></returns>
         public IActionResult deleteRole(string name)
         {
@@ -434,4 +551,10 @@
             }
         }
+        /// <summary>
+        /// Deletes a user from a role
+        /// </summary>
+        /// <param name="id">User id</param>
+        /// <param name="role">Role name</param>
+        /// <returns></returns>
         public IActionResult deleteRoleUser(string id, string role)
         {
